/** Example node.js app for serving random markers via socket.io **/

var app = require('http').createServer(handler);
var fs = require('fs');
var util = require('util');
var ns = require('node-static');
var io = require('socket.io').listen(app);
var net = require('net');
var file = new(ns.Server)("../static/", { cache: 600 });

// Listen on port 1337
app.listen(1337);

// Serve static content
function handler (req, res) {
  req.addListener('end', function() {
    file.serve(req, res, function(err, result) {
      if (err) {
        console.error('Error serving %s - %s', req.url, err.message);
        if (err.status === 404 || err.status === 500) {
          file.serveFile(util.format('/%d.html', err.status), err.status, {}, req, res);
        } else {
          res.writeHead(err.status, err.headers);
          res.end();
        }
      }
    });
  });
}

// Push random markers via socket.io
io.sockets.on('connection', function (socket) {
  //function random_point() {
  //  var lat, lng;
  //  lat = Math.random() * 180 - 90;
  //  lng = Math.random() * 360 - 180;
  //  socket.emit('marker', { lat: lat, lng: lng });
 // }

  //function insert_point(lat,lng) {
  //  socket.emit('marker', { lat: lat, lng: lng });
  //}

  var sock = net.createConnection(10000,"localhost");
  console.log('Attempting a connection');
  sock.on('connect', function (connect) {
    console.log('Connected');
    sock.on('data', function (data) {
    //  var data = c + ''; // make sure it's a string
      //var tmp = data.toString("utf-8").split("\n");
      //console.log('data`%s`', tmp[0]);
      //var parts = tmp[0].split(":");
      var parts = data.toString("utf-8").split(":");
      var lat, lng;
      lat = Number(parts[0]);
      lng = Number(parts[1]);
      if (lat != null && lng != null) {
        //console.log('split lat: %s  long: %s', parts[0], parts[1]);
        //lat.replace(/(\n|\r|\r\n)$/, '');
        //lat.replace(/(\n|\r|\r\n)$/, '');
	//lng.replace(/(\n|\r|\r\n)$/, '');
        //lng.trim;
        //console.log('passed lat: %s  long: %s', lat, lng);
        //console.log('Received data: `%s`', data);
        //insert_point(lat,lng);
        //lat=37.0000;
        //lng=127.5000;
        socket.emit('marker', { lat: lat, lng: lng });
      }
      //}
    })
    //socket.on("end", function () {
    //// ITS OVER!
    //})
  });


  //setInterval(function() { setTimeout(random_point, Math.random() * 1000) }, 500);
});
